<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
	xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
	extension-element-prefixes="java util"
	exclude-result-prefixes="java util gsf">

  
  <xsl:template name="wrappedDocument">
    <div id="gs-document">
      
      <xsl:call-template name="documentPre"/>
      <div id="gs-document-text" class="documenttext" collection="{/page/pageResponse/collection/@name}"><!-- *** -->

	<style>
	  /* Variation on detail given in:
	      http://stackoverflow.com/questions/2279396/how-to-remove-unwanted-space-between-rows-and-columns-in-table
	  */
	  
	  fieldset, form, label, legend,
	  table, caption, tbody, tfoot, thead, tr, th, td {
	    margin: 0;
	    padding: 0;
	    border: 0;
	    font-size: 100%;
	    font: inherit;
	    vertical-align: baseline;
	  }
      </style>

	<xsl:call-template name="create-html-header"/>
	
	<xsl:variable name="httpCollection">
	  <xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
	</xsl:variable>

	<gsf:variable name="cgiParamSite">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'site']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamD">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'd']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamCL">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'cl']/@value"/>
	</gsf:variable>
	
	<gsf:variable name="cgiParamPageWidth">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'pageWidth']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamPageHeight">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'pageHeight']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamPagePrefix">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'pagePrefix']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamPageSuffix">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'pageSuffix']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamNumPages">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'numPages']/@value"/>
	</gsf:variable>
	<gsf:variable name="cgiParamScaleFactor">
	  <xsl:value-of select="/page/pageRequest/paramList/param[@name = 'scaleFactor']/@value"/>
	</gsf:variable>

	
	<table id="gotoNavBar" align="center" width="{$cgiParamPageWidth}"> 
	  <tr>
	    <td align="left" width="20%">
	      <a href="javascript:musicStand.prevPageAnim(gs.cgiParams['d'],'.png')">
		<span id="prevpagespan" style="display: inline;">
		  <img class="lessarrow" src="interfaces/{$interface_name}/images/previous-small.png"/>
		  <span id="prevpageval">
		    <script language="javascript" type="text/javascript">musicStand.docwritePrevPageNum()</script>
		  </span>
		</span>
	      </a>
	      <script language="javascript" type="text/javascript">musicStand.activatePrevPageNum();</script>
	    </td>
	    <td align="center" width="60%">
	      <div>
		<form name="GotoForm" method="get" action="{$library_name}">
		  <input type="hidden" name="a" value="d" />
		  <input type="hidden" name="site" value="{$cgiParamSite}" />
		  <input type="hidden" name="c" value="{$collNameChecked}" />
		  <input type="hidden" name="excerptid" value="gs-document-text" />
		  <input type="hidden" name="d" value="{$cgiParamD}" />
		  <input type="hidden" name="cl" value="{$cgiParamCL}" />
		  <input type="hidden" name="pageWidth" value="{$cgiParamPageWidth}" />
		  <input type="hidden" name="pageHeight" value="{$cgiParamPageHeight}" />
		  <input type="hidden" name="numPages" value="{$cgiParamNumPages}" />
		  <input type="hidden" name="pagePrefix" value="{$cgiParamPagePrefix}" />
		  <input type="hidden" name="pageSuffix" value="{$cgiParamPageSuffix}" />
		  <input type="hidden" name="scaleFactor" value="{$cgiParamScaleFactor}" />
		  <input type="hidden" name="view" value="simple" />
		  <input type="text" name="gp" size="3" maxlength="4" />
		  <input type="submit" value="go to page" /> <!-- make language fragment multilingual -->
		  <script language="javascript" type="text/javascript">
		    musicStand.docwriteOptOfPages();
		  </script>
		</form>		  
	      </div>		  
	    </td>
	    <td align="right" width="20%">
	      <a href="javascript:musicStand.nextPageAnim(gs.cgiParams['d'],'.png')">
		<span id="nextpagespan" style="display: inline">
		  <span id="nextpageval">
		    <script language="javascript" type="text/javascript">musicStand.docwriteNextPageNum()</script>
		  </span>
		  <img class="morearrow" src="interfaces/{$interface_name}/images/next-small.png"/>
		</span>
	      </a>
	    </td>
	    <script language="javascript" type="text/javascript">musicStand.activateNextPageNum();</script>
	  </tr>
	</table>
	<table width="100%">
	  <tr>
	    <td/>
	    <td>
	      <div id="thispage" style="cursor: e-resize; background: white;        position: relative; left: 0px; top: 0px;        width: {$cgiParamPageWidth}px; height: {gs.cgiparam.PageHeight}px;">
		<a onClick="return false;" onContextMenu="return false;" onMouseDown="return musicStand.nextOrPrevPageEvent(event,gs.cgiParams['d'],'.png')" onMouseUp="return false;">
		  <img border="0" height="{$cgiParamPageHeight}" id="thispageimg" src="{$httpCollection}/images/blank.gif" width="{$cgiParamPageWidth}"/>
		</a>
		<div id="nextpagediv" style="clip : rect(0px, {$cgiParamPageWidth}px, {$cgiParamPageHeight}px, {$cgiParamPageWidth}px);">
		  <img border="0" id="nextpageimg" src=""/>
		</div>
		<div id="prevpagediv" style="clip : rect(0px, {$cgiParamPageWidth}px, {$cgiParamPageHeight}px, {$cgiParamPageWidth}px);">
		  <img border="0" id="prevpageimg" src=""/>
		</div>
		<div id="animedgebleed" style="clip : rect(0px, {$cgiParamPageWidth}px, {$cgiParamPageHeight}px, {$cgiParamPageWidth}px);">								</div>								<div id="loading">
		<table height="100%" width="100%">
		  <tr>
		    <td width="45%">											</td>											<td align="left">
		    <span id="loadingdots">loading</span>
		  </td>
		  </tr>
		</table>
	      </div>
	      </div>
	      <style>
		div.postit    {background-color: rgba(250,250,200,0.7);  color: black; }
		a.postit:link   {background-color: rgba(250,250,200,0.7); color: black; text-decoration: none; }
		a.postit:visited {background-color: rgba(250,250,200,0.7); color: black; text-decoration: none; }
		
		a.postit:hover   {color: rgba(150,110 ,0,0.7); }
	      
		div.pagemenu    { background-color: rgba(250,250,200,0.7); color: black; }
	      </style>
	      
	      
	      
	      <div id="coord" 
		   style="position: absolute; left: 0px; top: 0px; z-index: 10; visibility: hidden;">
		<xsl:comment>Mouse coord debug div</xsl:comment>
	      </div>

<!--
<style>

div.postit    {background-color: _postitbgcol_; 
		color: black; }
a.postit:link    {background-color: _postitbgcol_; 
		      color: black;
		      text-decoration: none; }
a.postit:visited {background-color: _postitbgcol_; 
		      color: black; 
		      text-decoration: none; }

a.postit:hover   {color: _postitselcol_; }

</style>

<div id="expediteee" 
     style="position: absolute; right: 4px; top: 2px; z-index: 10; visibility: visible;">
  <a id="expediteemode" class="postit" href=""></a>

  <script type="text/javascript">
    var href=document.getElementById("expediteemode");
    var url = document.location.toString();

    var expediteeVal       = (expeditee) ? 1 : 0;
    var toggleExpediteeVal = (expeditee) ? 0 : 1;

    var replaceRE;
    var withStr = "&expeditee="+toggleExpediteeVal;

    var cutpos = url.indexOf("&expeditee=");

    if (cutpos>=0) {
      replaceRE = new RegExp("&expeditee="+expediteeVal);      
    }
    else {
      replaceRE = new RegExp("$");      
    }

    url = url.replace(replaceRE,withStr);
    href.setAttribute("href",url);

    if (expeditee) {
        // toggle 
        href.innerHTML = '<span style="font-size: 9pt;"><i>Switch to standard mode</i></span>';
    }
    else {
        href.innerHTML = '<span style="font-size: 9pt;"><i>Switch to Expeditee mode</i></span>';
    }

  </script>


</div>

-->


							
              <div class="editable-menu" id="pagemenu" onmouseout="javascript:return musicStand.hidePageMenu(this,event);" style="position: absolute; right: 4px; bottom: 2px;        z-index: 10; visibility: hidden;">
		<font size="-1">
		  <div class="pagemenu" id="pagemenu1">Cancel turn</div>
		  <div class="pagemenu" id="pagemenu2">Next page</div>
		  <div class="pagemenu" id="pagemenu3">Previous page</div>
		</font>
	      </div>
	      
	      <div id="annotateCanvas" style="position: absolute; left: 0px; top: 0px; visibility: visible; z-index: 2;" >
		<!-- filler -->
	      </div>
	    </td>
	    <td>
	      <div id="slidercontainer" style="background: white; position: relative; left: 0px; top: 0px; width: 40px; height: {$cgiParamPageHeight}px;">
		<div id="sliderbg">
		  <div id="slidertrackabove" style="position: absolute; left: 8px; top: 0px; width: 4px; height: 500px; z-index:4; background-color:#606060;">
		    <!-- filler -->
		  </div>
		  <div id="slidertrackbelow" style="position: absolute; left: 10px; top: 500px; width: 1px; height: 100px; z-index:4; background-color:#606060;">
		    <!-- filler -->
		  </div>
		</div>
		
		<div id="sliderpos" style="width:30px; height:11px;">
		  <img height="11" src="{$httpCollection}/images/brown2-slider.png" width="30"/>
		</div>
		<script language="javascript" type="text/javascript">
		  <xsl:text disable-output-escaping="yes">var username = musicStand.getUsername();
	  var metaval;

	  if (username != null) {
	      var metaname = username + "-sliderposTop";
	      metaval = 700; // ***** major hack ****
	      //metaval  = gsapi.getLiveMetadata(gs.cgiParams["d"],metaname);
	      //if (metaval == "") {
	      //    // fallback to looking up non-user specific one
	      //    metaval  = gsapi.getLiveMetadata(gs.cgiParams["d"],"sliderposTop");
	      //}
	  }
	  else {
	      //metaval  = gsapi.getLiveMetadata(gs.cgiParams["d"],"sliderposTop");
	      metaval = 700; // ***** major hack ****
	  }
	  var sliderposTop = parseInt(metaval);

	  var speedBreak = musicStand.getSpeedBreak();

	  if (sliderposTop &gt; 0) {
	      sliderposTop *= musicStand.getScaleFactor();
	      speedBreak = sliderposTop;
	      musicStand.setSpeedBreak(speedBreak);
	  }

	  var sliderpos = document.getElementById('sliderpos');
	  sliderpos.style.top = speedBreak + "px";
          sliderpos.style.left = "-8px";
	  sliderpos.onmousedown = dragSlider;
	  var sliderbg = document.getElementById('sliderbg');
	  sliderbg.onmousedown = dragSlider;


	  var trackabove = document.getElementById('slidertrackabove');
	  trackabove.style.height = speedBreak + "px";

	  var trackbelow = document.getElementById('slidertrackbelow');
	  trackbelow.style.top = speedBreak + "px";
	  trackbelow.style.height = (gs.cgiParams["pageHeight"] - speedBreak) + "px";
		  </xsl:text>
		</script>
	      </div>
	    </td>
         </tr>
        </table>
					  
      </div>
    </div>
  </xsl:template>






  
  <xsl:template name="wrappedDocumentXXX">
    <xsl:choose>
      <!-- NOTE: alb = ajax load bypass -->
      <!-- 
	   If the docType is hierarchy and we want to bypass the ajax load then do this 
	   OR If the docType is hierarchy and we have asked for the expanded document OR we have asked for the top level document then do this 
      -->
      <xsl:when test="/page/pageResponse/document/@docType = 'hierarchy' and (/page/pageRequest/paramList/param[@name = 'alb']/@value = '1' or (string-length(/page/pageRequest/paramList/param[@name = 'd']/@value) > 0 and (/page/pageRequest/paramList/param[@name = 'ed']/@value = '1' or not(util:contains(/page/pageResponse/document/@selectedNode, '.')))))">
	<div id="gs-document">
	  <xsl:call-template name="documentPre"/>
	  <div id="gs-document-text" class="documenttext" collection="{/page/pageResponse/collection/@name}"><!-- *** -->
	    <xsl:for-each select="documentNode">
	      <xsl:call-template name="wrapDocumentNodes"/>
	    </xsl:for-each>
	  </div>
	</div>
      </xsl:when>
      <xsl:when test="/page/pageResponse/document/@docType = 'paged' or /page/pageResponse/document/@docType = 'pagedhierarchy'">
	<div id="gs-document">							
	  <div id="tocLoadingImage" style="text-align:center;">
	    <img src="{util:getInterfaceText($interface_name, /page/@lang, 'loading_image')}"/><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.loading')"/><xsl:text>...</xsl:text>
	  </div>
	</div>
	<script type="text/javascript">
	  <xsl:text disable-output-escaping="yes">
						$(window).load(function()
						{
							var sectionID = gs.cgiParams.d;
							var callbackFunction = null;
							if(sectionID.indexOf("\\.") == -1)
							{
								callbackFunction = function()
								{
									focusSection(sectionID);
								};
							}
						
							var docID = sectionID.replace(/([^.]*)\..*/, "$1");
							var url = gs.xsltParams.library_name + "?a=d&amp;c=" + gs.cgiParams.c + "&amp;excerptid=gs-document&amp;dt=hierarchy&amp;d=" + docID;
							loadTopLevelPage(callbackFunction, url);
						});
	  </xsl:text>
	</script>
      </xsl:when>
      <xsl:otherwise>
	<div id="gs-document">							
	  <div id="tocLoadingImage" style="text-align:center;">
	    <img src="{util:getInterfaceText($interface_name, /page/@lang, 'loading_image')}"/><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.loading')"/><xsl:text>...</xsl:text>
	  </div>
	</div>
	<script type="text/javascript">
	  <xsl:text disable-output-escaping="yes">
						$(window).load(function()
						{
							loadTopLevelPage(function()
							{
								//Don't focus the section until the table of contents is loaded
								var tocCheck = function()
								{
									if(gs.variables.tocLoaded)
									{
										focusSection("</xsl:text><xsl:value-of select="/page/pageResponse/document/@selectedNode"/><xsl:text disable-output-escaping="yes">");
									}
									else
									{
										setTimeout(tocCheck, 500);
									}
								}
								tocCheck();
							});
						});
	  </xsl:text>
	</script>
      </xsl:otherwise>
    </xsl:choose>
		
    <div class="clear"><xsl:text> </xsl:text></div>
  </xsl:template>

</xsl:stylesheet>
